proc viewhost { name group goto} {
# File pattens.tcl
 global patten_share patten_hosts patten_groups patten2 patten2a patten3 patten_info1 patten_info2

# GlobalVars
 global font PASSWORD timeout C_HOST C_GROUP
 global H_${name}_IP H_${name}_Browse

 set addr [nmblookup $name]
#.trt4 configure -text $name
#.trt6 configure -text $group

#set H_${name}_IP $addr
defifndef H_${name}_Browse no
if { [set H_${name}_Browse] == "now" } { return {} }
set H_${name}_Browse now
set passflag "0"

set get_group {}
set get_comment ""

if { $addr == "" } {
	spawn -nottyinit smbclient -L $name -W $group
	} else {
	spawn -nottyinit smbclient -L $name -W $group -I $addr
	}
set id $spawn_id

expect {
   -i $id Password: {
	if { $passflag == "0" } {
	  exp_send "$PASSWORD\r"
	} {
	  exp_send "none\r"
	}
	set passflag 1
	exp_continue
	}
   -i $id -indices -re $patten_info1 { 
	set get_domain  $expect_out(1,string)
	set get_os      $expect_out(2,string)
	set get_comment $expect_out(3,string)
	put "Get Info1......."
	addhost $name $get_comment $get_domain
	exp_continue
	}
   -i $id -indices -re $patten_info2  {
	set get_server  $expect_out(1,string)
	set get_user    $expect_out(2,string)
	set get_group   $expect_out(3,string)
	set get_domain  $expect_out(4,string)
	put "Get Info2......"

	exp_continue
	}
   -i $id timeout {close -i $id;puts "Timeout $timeout sec.........."}
   -i $id $patten_share {
	put {Share Part...........}
	set res {put "Unexpected end of input while reading shares........."}
	expect {
	    -i $id -indices -re $patten3 {
		put "<<$expect_out(1,string)<:$expect_out(3,string):>$expect_out(4,string)>>"
		if { $expect_out(3,string)=="Disk"} {
			addshare $name $expect_out(1,string) $expect_out(4,string)
			}
		if { $expect_out(1,string)=="" } {
			set res "exp_continue"
			} else {
			exp_continue }
		}
	#   -i $id "\r\n\r\n" {
	#	put "Shares Ended Successfully......."
	#	set res "exp_continue"
	#	}
	    
	    }
	eval $res
	}
   -i $id $patten_hosts {
	set res {put "Unexpected end of Input while reading hosts........."} 
	expect {
	   -i $id -indices -re $patten2 {
		put "!$expect_out(1,string)!$expect_out(3,string)!"
		addhost $expect_out(1,string) $expect_out(3,string) $group
		if { $expect_out(1,string)=="" } {
			set res exp_continue
			} else exp_continue
		}
	   }
	eval $res	
	}
   -i $id $patten_groups {
	expect {
	   -i $id "\r\n\r\n"   {
		put "Internal Error in VIEWHOST.......... Possible unsupported 'smbclient'"
		}
	   -i $id -indices -re $patten2a {
		addgroup $expect_out(1,string) $expect_out(3,string)
		put "?$expect_out(1,string)?$expect_out(3,string)?"
                exp_continue
		}
	   }
	}
   }
#   close -i $id
   wait  -i $id
   global H_${name}_Browse
   set H_${name}_Browse host
   if { $group == $get_group } { set H_${name}_Browse group }
   if { $get_group == "" } {
	if { $name == $C_HOST && [set H_${name}_Browse] != "failed" } {
		.shares configure -state normal
		.shares insert end "<FAILED>"
		.shares configure -state disabled
		}
	set H_${name}_Browse failed
	}
   global C_SHARE
   set C_SHARE {}
   puts "Terminated.. <$name>"
   if { $goto == 1 && $get_group != "" } {
      new_group_request $get_group 0
      new_host_request $name 0
   }
}
